warning off;
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
// declaration of variables, the # of variables must be equal to the # of equations
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

var 
    C $C$, C_H $C^H$, C_M $C^M$, N $N$, W_oil $W^{oil}$, D $D$, W,     // ( var for HH)1-7
    K $K$, Y_no $Y^{no}$, Nn $N^n$, prof_no $\Pi^{no}$,                //( var for SOE)8-11
    X $X$, Q $Q$, phi_func $\Phi(x)$, phi_func_der $\Phi\prime(x)$, x, // 12-16
    Y_H $Y^H$, Y_M $Y^M$,                                              // (Final Good producers)17-18
    P_star $P^*$, X1 $X^1$, X2 $X^2$, X3 $X^3$,                       //( var for retailers SOE)19-22
    NW $NW$, L,                                                        // (Wholesale banks)23-24
    B_G $B^G$,                                                         //25 claim of CB on Gov
    B, G, T, trans $Tr$, S,                                            // Government 26-30
    L_OF $L^{OF}$,                                                     // Oil Fund OF $OF$,31
    P_M $P^M$, P, P_H $P^H$, pi $\pi$, P_no $P^{no}$,                  // Prices and exchange rate  e,32-36
    prof_K $\Pi^K$, prof_R $\Pi^R$, prof_L $\Pi^L$, prof_D $\Pi^D$,    // profit 37-40
    R_D $R^D$, R , R_IB $R^{IB}$, R_k $R^{k}$, R_B $R^B$, R_CB $R^{CB}$, R_star $R^*$, //(Interest rates)41-47
    OR,                                                                //(OIL) 48
     
    Y_oil $Y^{oil}$,                                                    //49
    No $N^o$, K_oil $K^{oil}$, P_oil $P^{oil}$, Q_oil $Q^{oil}$,         //50-53
    eps1 $\varepsilon^1$, eps2 $\varepsilon^2$, eps3 $\varepsilon^3$,   //54-56
    shock_oil $\epsilon_{oil}$                                           //57
    cap_qual1 $\xi_1$, GDP $Y$,                                         //58-59

OF,                                                                      //60

r_D $r^D$ , r_IB $r^{IB}$ ,r_CB $r^{CB}$, r_star $r^*$, r_k $r^k$ ,r ,r_B $r^B$                                   //61-67

 // Central Bank Psi $\Psi$,
 B_CB $B^{CB}$                                                          //68 Claim CB on Banking
%%%%%%%
D_1,B_1 , L_1                                                     // 69-72
; 
 


//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// declaration of the stochastic shocks 
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

varexo ue1 $u^{e1}$, ue2 $u^{e2}$, ue3 $u^{e3}$, u_oil $u^{oil}$, shock_capital $\epsilon^{K}$ ;// ,shock_mon $\epsilon^{m}$;

//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// declaration of the different parameters
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
load steady_state_oil.mat 
load Parameters_1.mat;
parameters

           beta_p $\beta$, sigma_c $\sigma_c$, alpha_H $\alpha_H$, eta_P $\eta_P$, phi $\phi$, xi_N $\xi_N$, // Household Parameters
           rho $\rho$, // Wholesale producers
           delta_k $\delta_k$, delta_o $\delta_o$, chi_x $\chi_x$, // Capital Producers
           alpha_p $\alpha_p$, theta $\theta$,
           eta_D $\eta^D$, eta_B $\eta^B$,  eta_L $\eta^L$,//
           epsilon_D $\epsilon^D$, kappa_D $\kappa^D$, // Deposit banks
           u,  // interest rate spread and subsidy
           nu $\nu$,  rho_G $\rho^G$, tau_w $\tau_w$,  tau_c $\tau_c$, // Government 
           rho_Rcb $\rho^R_{CB}$,  rho_pi $\rho_\pi$,
           rho_eps1 $\rho^{\epsilon}_1$, rho_eps2 $\rho^{\epsilon}_2$, rho_eps3 $\rho^{\epsilon}_3$, rho_oil $\rho^{oil}$, rho1 $\rho^1$,
           rho_cap $\rho_\xi$, rho_Rstar $\rho_R^*$, rho_shock_oil $\rho_o$, rho_TR $\rho_\Gamma$, rho_M $\rho_M$, zeta $\zeta$, alpha_oil $\alpha_o$
rho_BG,rho_OF,rho_y
;

// define the parameters
 %% Run steadystate_Finder before run dynare file

for i=1:length(M_.params) 
    deep_parameter_name = M_.param_names(i,:);
    eval(['M_.params(i)  = ' deep_parameter_name ' ;'])
end;

 D_bar     = D_ss;
 B_bar     = B_ss;
 L_bar     = L_ss ;
 P_oil_bar = P_oil_ss ;
 B_G_bar   = B_G_ss   ;
 G_bar     = G_ss      ;
 R_CB_bar  = R_CB_ss  ;
 R_D_bar   = R_D_ss;
 R_IB_bar  = R_IB_ss;
 R_bar     = R_ss;
 r_IB_bar  = r_IB_ss ;
 r_CB_bar  = r_CB_ss  ;
 OR_bar    = OR_ss    ;
 pi_bar    = pi_ss    ;
 GDP_bar   = GDP_ss   ;
 B_CB_bar  = B_CB_ss  ;
///%%%%%%%






clear Parameters_1.mat;
clear steady_state_oil.mat 

 


//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// write the model 
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
model;  //  







// Household FOCs  
///////////////////////////////////////////////////////////////
xi_N * N^phi = C ^(-sigma_c) * W ;                                               // 1   The IRFs are similar to those of log utility with -0.5<phi<-1 
1/r_D = beta_p* ( (C(+1)/C)^(-sigma_c))  * (1/pi(+1)) ;  //      2                            
C + D_1 + T = r_D(-1) * D_1(-1) / pi + W * N + trans + prof_R + prof_K + prof_L + prof_D + zeta * prof_no;                        // 3 BC HH  

C_H = (1-alpha_H)*(P_H/P)^(-eta_P)*C; //4
C_M = alpha_H* (P_M/P)^(-eta_P) * C; //5

P =((1-alpha_H) * P_H^(1-eta_P) + alpha_H * P_M^(1-eta_P))^(1/(1-eta_P)); //6
C_M = Y_M; //7

// Wholesale producers  
////////////////////////////////////////////////////////////////////////
Y_no = exp(eps1)*K(-1)^(rho)*Nn^(1-rho); //8
(1-rho) * Y_no / Nn = W / P_no; //9
prof_no = P_no * Y_no - W * Nn - r * (1-u) * K(-1);  //10
rho * Y_no / K(-1) = r * (1-u) /(P_no); //11

//Capital producers  
///////////////////////////////////////////////////////////////////////
x = X/X(-1);                                                                 // 12 Aux var
phi_func = 1- chi_x/2*(x-1)^2/(x);                                           // 13 Cost function for capital producers
phi_func_der = - chi_x/2 *((x^2-1)/x^2); //chi_x*((x-1)/x)*(((x-1)/(2*x))-1);                            // 14 Derivative of the cost function            
K = (1-delta_k) * K(-1) + phi_func * X;                                              // 15 Dyanmic of capital
Q*(x * phi_func_der + phi_func) +(1/r_D)*(Q(+1)*phi_func_der(+1) * x(+1)^2 )  = 1; // 16 The FOC for capital producer    
prof_K = Q * K - (1-delta_k) * Q * K(-1) - X;                                               // 17  Definition of capital producer profit

// Retailers  
///////////////////////////////////////////////////////////////////////
X1 = P_star^(1-theta)*Y_no*(theta-1)/theta +alpha_p*1/r_D*pi(+1)^theta*(P_star/P_star(+1))^(1-theta)*X1(+1);        // 18 Aux var
X2 = P_star^(-theta)*Y_no*P_no+alpha_p*1/r_D*pi(+1)^(1+theta)*(P_star/P_star(+1))^(-theta)*X2(+1);                  // 19  Aux var        
X2 = X1;       //20
alpha_p * pi^(theta-1) + (1-alpha_p)*P_star^(1-theta) = 1;                                                            // 21  Dynamic of the inflation
X3 = (1-alpha_p)*P_star^(-theta) + alpha_p * pi^theta * X3(-1);                                                         // 22  Aux var
X3 * Y_H = Y_no;                                                                                       // 23  Market clearing of goods
prof_R =  (P_H *Y_H - P_no*Y_no) / P ;                                                                              // 24  definition of the profit for retailers 
P_H = (alpha_p*P_H(-1)^(1-theta)+(1-alpha_p)*P_star^(1-theta))^(1/(1-theta));        // 25 Definition of the price index  
P_M =  rho_M*P_M(-1) +(1-rho_M)*P_oil ; //26

pi= P/P(-1); //27

 
// DEPOSIT BANK (2 Equations)
///////////////////////////////////////////////////////////////////////

(1+epsilon_D)/epsilon_D * R_D = R_IB - kappa_D/2*(R_D/R_D(-1)-1) * R_D/R_D(-1) + 1/R_D * 1/epsilon_D * (R_D(+1)/R_D-1)* R_D(+1)/R_D;  //28 FOC for deposit banks
prof_D = (r_IB - r_D) * D_1  - kappa_D/2 * (r_D/r_D(-1) - 1)^2 * D_1;                                     // 29 Deposit banks profit


//  Lending Banks  
///////////////////////////////////////////////////////////////////////
B_1 + Q * L_1 = D_1 + B_CB + L_OF + NW ; //30

R_k = (R + (1-delta_k) * Q )/Q(-1);      //31                                              //  
NW =     (r_k-r_CB(-1))*Q(-1)*L_1(-1)+(r_B(-1)-r_CB(-1))*B_1(-1)-(r_IB(-1)-r_CB(-1))*D_1(-1)-(r_star(-1)-r_CB(-1))*L_OF(-1)
    -r_IB(-1)*eta_D/2*(D_1(-1)-D_bar)^2-eta_B/2*(B_1(-1)-B_bar)^2*r_B(-1)-eta_L/2*(L_1(-1)-L_bar)^2*r_k+r_CB(-1)*NW(-1);  //32
//NW(+1) = (R_k(+1)-R_CB)*Q*L+(R_B-R_CB)*B-(R_IB-R_CB)*D_1-(R_star-R_CB)*L_OF-R_IB*eta_D/2*(D_1-D_bar)^2-eta_B/2*(B_1-B_bar)^2*R_B-eta_L/2*(L-L_bar)^2*R_k+R_CB*NW; // +((e-e(-1))/e(-1)-R_CB(-1))*e(-1)*Psi(-1) //31
K = cap_qual1 * L_1(-1) ; //33
prof_L = NW;//34

R_IB = R_CB/(1+eta_D *(D_1-D_bar));//35
R_B = R_CB/(1-eta_B*(B_1-B_bar));//36
R_k = R_CB(-1)/(1-eta_L/Q(-1)*(L_1(-1)-L_bar));  //37

 
// OIL Sector  
///////////////////////////////////////////////////////////////////////
P_oil = (1-rho_oil)* P_oil_bar + rho_oil * P_oil(-1) + shock_oil;//38
Q_oil = exp(eps3)*K_oil(-1)^(rho1)*No^(1-rho1);//39

Y_oil = P_oil*Q_oil;//40
OR = (1-alpha_oil) * Y_oil - W_oil * No;//41
No = (1-alpha_oil) * (1-rho1)*P_oil*Q_oil/W_oil;//42
K_oil(1)  = (1-delta_o) * K_oil  + alpha_oil * Y_oil   ;//43
W_oil = W;//44

 
// OIL FUND  
///////////////////////////////////////////////////////////////////////
OF =   (1 - nu) * OR - L_OF ; //45 

//OF = OF(-1) + r_star(-1) * L_OF(-1) + (1 - nu) * OR - L_OF ; //  
//L_OF(+1) = rho_OF*L_OF-(1-rho_OF)*(OR-OR_star);
//R_star = R_CB*(e/(e(+1)*pi(+1)));

 
// Government 
///////////////////////////////////////////////////////////////////////

T + nu*OR + B_1 + B_G  + (1-zeta) * prof_no = r_B(-1) * B_1(-1) + r_CB(-1) * B_G(-1) + trans + G + S;//46
B_G = 0 ;%rho_BG * B_G(-1) + (1-rho_BG) * B_G_bar ; //47
T = tau_c * (prof_R + prof_K + prof_L + prof_D + zeta * prof_no) + tau_w * W * N ; // 48 Gov fiscal policy 
trans = rho_TR * trans(-1) + (1-rho_TR) * nu * OR;//49
G = (1-rho_G)* G_bar + rho_G * G(-1);     //50
S = u * r * K(-1);//51
 
///////////////////////////////////////////////////////////////////////
// Central Bank  
///////////////////////////////////////////////////////////////////////
R_CB = R_star * pi(1) ;     //52

1-R_CB = (1-rho_Rcb) * ((1-R_CB_bar) + rho_pi * (pi-pi_bar) + rho_y * (log(GDP/GDP_bar))) + rho_Rcb * (1-R_CB(-1)) ; //+ shock_mon ; //53

//log(R_CB/R_CB_bar) = rho_Rcb * rho_pi * log(pi(-1)) + (1-rho_Rcb) * log(R_CB(-1)/R_CB_bar);  // 52 Taylor rule +rho_y*log(GDP/Y_check))
//R_CB/R_CB_bar=(R_CB(-1)/R_CB_bar)^rho_Rcb*((pi)^rho_pi*((GDP/GDP(-1)))^rho_y)^(1-rho_Rcb);//52
//R_CB = R_CB_bar + pi + rho_pi * (pi-pi_bar) + rho_y * ( GDP - GDP_bar)
//R_star = rho_Rstar * R_star(-1) + (1-rho_Rstar) * R_CB_bar ;     //53
//prof_CB = B_CB-(1-R_CB)*B_CB(-1)+(B_G-B_G(-1));
//Psi = rho_psi1*Psi(-1)+rho_psi3*(pi-pi_star);   //+rho_psi2*(e-e_star)
//log(R_CB(+1)/R_CB_bar) = (1-rho_Rcb)*log(R_CB/R_CB_bar)+rho_Rcb*(rho_pi*log(pi));  // 40 Taylor rule +rho_y*log(GDP/Y_check))
//R_CB(+1)/R_CB_bar=(R_CB/R_CB_bar)^rho_Rcb*((pi)^rho_pi*((GDP(+1)/GDP))^rho_y)^(1-rho_Rcb);
// R/R_bar=(R(-1)/R_bar)^gammmaR*((PI/PI_bar)^gammmaPI*((yd/yd(-1)*mu_z)/exp(LambdaYd))^gammmay)^(1-gammmaR)*exp(epsm);
//log(rf/rf_bar) = (1-rho_rf)*log(rf(-1)/rf_bar)+rho_rf*(rho_pi*log(pi(-1))+rho_y*log(GDP/Y_check))-shock_rf;  // 40 Taylor rule


///////////////////////////////////////////////////////////////////////
// Market clearing
///////////////////////////////////////////////////////////////////////
//Y_oil + Y_H + Y_M = C + X + G + delta_o*K_oil(-1) ; %+ u*R*K(-1);//53
//Y_no + Y_M = C + G + X ;
N = Nn + No; //54
GDP = C + X + G + Y_oil - Y_M;//55

// processes  
///////////////////////////////////////////////////////////////////////
eps1=rho_eps1*eps1(-1)+ ue1;                                     // Tech shock process 56
eps2=rho_eps2*eps2(-1)+ ue2;                                     // Tech shock process 57
eps3=rho_eps3*eps3(-1)+ ue3;    //58

// Tech shock process
shock_oil = rho_shock_oil * shock_oil(-1) + u_oil; //59
cap_qual1 = (1-rho_cap) * 1 + rho_cap * cap_qual1(-1) + shock_capital; //60

//////////////////////////////////
r_D    = R_D_bar ^0.25; //61
r_IB   = R_IB_bar^0.25;    //62           %% Interbank interest rate
r_CB   = r_IB_bar; //63
r_star = r_CB_bar; //64
r_k    = r_CB_bar; //65
r      = (1+R_bar) ^ 0.25 - 1; //65
r_B    = r_CB_bar ; //67

L_OF =  rho_OF * L_OF(-1) - (1-rho_OF) * (OR-OR_bar);//68


%%%%
 

 
D_1  = D(1)   * pi(1) ; //69
B_1  = B(1)   * pi(1) ;//70
L_1 = L(1)* pi(1) ;//71
%L_1 = L ; //71
end;
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
// initialize the different variables at their steady state
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
load steady_state_oil.mat 
initval;

Q = Q_ss; prof_K = prof_K_ss;  Y_no = Y_no_ss; Nn = Nn_ss;  No = No_ss;
K = K_ss; L = L_ss; W = W_ss; prof_no = prof_no_ss; P_no = P_no_ss; X = X_ss;
x = 1; 
R_D = R_D_ss;  R_IB = R_IB_ss; R = R_ss; R_CB = R_CB_ss; R_star = R_star_ss; R_k = R_k_ss; R_B = R_B_ss;   
r_D = r_D_ss; r_IB = r_IB_ss; r = r_ss; r_CB = r_CB_ss; r_star = r_star_ss;   r_k = r_k_ss; r_B = r_B_ss; 
 
P_M = P_M_ss; P_H = P_H_ss; P = P_ss; P_star = P_star_ss;
Y_H = Y_H_ss; Y_M = Y_M_ss ; C_H = C_H_ss; C_M = C_M_ss; C = C_ss;

B = B_ss; G = G_ss; trans = trans_ss; T = T_ss; S = S_ss; B_G = B_G_ss;
NW = NW_ss; prof_L = prof_L_ss; prof_D = prof_D_ss;
P_oil = P_oil_ss; Y_oil = Y_oil_ss; K_oil = K_oil_ss; Q_oil = Q_oil_ss; No = No_ss; W_oil = W_oil_ss; OR = OR_ss;
N = N_ss; D = D_ss;  B_CB = B_CB_ss;     

phi_func = phi_func_ss;
phi_func_der = phi_func_der_ss;

X1 = X1_ss ; X2 = X2_ss; X3 = X3_ss; prof_R = prof_R_ss;
L_OF = L_OF_ss;  OF = OF_ss; pi = pi_ss;   GDP = GDP_ss;

eps1 =0; eps2 =0; eps3 =0; shock_oil = 0; cap_qual1=1; ue1=0; ue2=0; ue3=0; u_oil=0; shock_capital=0;

D_1  = D_ss; B_1  = B_ss; L_1=L_ss;

end;

//%%%%%%%%%%%%%%%%%%%%%%%%%
// compute the steady state
//%%%%%%%%%%%%%%%%%%%%%%%%%
write_latex_dynamic_model;
write_latex_static_model;

//resid;

steady;

//model_diagnostics(M_,options_,oo_)

//model_info;

check;

shocks; 
//var ue1; stderr 0.01; 
var u_oil; stderr 0.01; 
//var ue3; stderr 0.01;
//var shock_capital; stderr 0.01; 
//var shock_mu; stderr 0.01;
end;

//stoch_simul(order=1, irf=20) ;
stoch_simul(order=1, irf=20) ;//GDP  Y_no Y_oil Y_M K K_oil NW P_no R W  R_k R_CB Q pi Nn No N shock_oil; // eps1 eps3 shock_oil;
// close;

//save('bgg','oo_','M_')
//save('nobgg','oo_','M_')
//save('norottem','oo_','M_')
//save('noCapCost','oo_','M_')
//save('basel1','oo_','M_')
//model_diagnostics(M_,options_,oo_)